class
	ANTLR_AST_NODE

create
	make

feature {NONE}

	make (antlr_c_node: POINTER)
		local
			i, count: INTEGER
		do
			type := c_get_type (antlr_c_node)
			token_text := c_get_token_text (antlr_c_node)
			from
				create {LINKED_LIST [ ANTLR_AST_NODE ]}children.make
				i := 0
				count := c_get_child_count (antlr_c_node)
			until
				i >= count
			loop
				children.extend (create {ANTLR_AST_NODE}.make (c_get_child (antlr_c_node, i)))
				i := i + 1
			end
		end

feature {ANY}

	type: INTEGER
	token_text: STRING
	children: LIST [ ANTLR_AST_NODE ]

feature {NONE}

	c_get_type (antlr_c_node: POINTER) : INTEGER
		external
			"C inline use <antlr3.h>"
		alias
			"[
				pANTLR3_BASE_TREE tree = $antlr_c_node;
				return tree->getType(tree);
			]"
		end

	c_get_token_text (antlr_c_node: POINTER) : STRING
		external
			"C inline use <antlr3.h>"
		alias
			"[
				pANTLR3_BASE_TREE tree = $antlr_c_node;
				pANTLR3_COMMON_TOKEN token = tree->getToken(tree);
				return eif_string((token->getText(token) != NULL) ? token->getText(token)->chars : token->tokText.chars);
			]"
		end

	c_get_child_count (antlr_c_node: POINTER) : INTEGER
		external
			"C inline use <antlr3.h>"
		alias
			"[
				pANTLR3_BASE_TREE tree = $antlr_c_node;
				return tree->getChildCount(tree);
			]"
		end

	c_get_child (antlr_c_node: POINTER; i: INTEGER) : POINTER
		external
			"C inline use <antlr3.h>"
		alias
			"[
				pANTLR3_BASE_TREE tree = $antlr_c_node;
				return tree->getChild(tree, $i);
			]"
		end

end
