class
	AST_DIRECT_DECLARATOR

inherit
	AST_NODE

create
	make_from_antlr

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Art_direct_declarator
		local
			declarator_suffix_start_index: INTEGER
		do
			make_root (init_parent)

			if node.children.first.type = C_op_open_parenthesis then
				create declarator.make_from_antlr (node.children.i_th (2), Current)
				declarator_suffix_start_index := 4
			else
				identifier := node.children.first.token_text
				declarator_suffix_start_index := 2
			end
		end

feature {ANY}

	identifier: STRING
	declarator: AST_DECLARATOR

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_direct_declarator (Current)
			if visit_children then
				if declarator /= Void then
					declarator.accept (v)
				end
			end
			v.end_visit_direct_declarator (Current)
			v.post_visit (Current)
		end

invariant
	identifier /= Void or declarator /= Void

end
