deferred class
	AST_NODE

inherit
	ANTLR_AST_TYPE_CONSTANTS

feature {NONE}

	make_root (init_parent: AST_NODE)
		do
			parent := init_parent
			create properties.make (0)
		end

feature {ANY} -- AST

	parent: AST_NODE assign set_parent

	accept (v: AST_VISITOR)
		deferred
		end

feature {ANY} -- properties

	properties: HASH_TABLE [ STRING, STRING ]

feature {AST_NODE}

	set_parent (init_parent: AST_NODE)
		do
			parent := init_parent
		end

	visit (l: LIST [ AST_NODE ]; v: AST_VISITOR)
		local
			c: CURSOR
		do
			c := l.cursor
			from
				l.start
			until
				l.after
			loop
				l.item.accept (v)
				l.forth
			end
			l.go_to (c)
		end

feature {NONE} -- invariant helpers

	ast_children_from_fields : LIST [ AST_NODE ]
		local
			l: LINKED_LIST [ ANY ]
			internal: INTERNAL
			i: INTEGER
		do
			from
				create l.make
				create internal
				i := internal.field_count (Current)
			until
				i < 1
			loop
				if not internal.field_name (i, Current).is_equal ("parent") then
					l.extend (internal.field (i, Current))
				end
				i := i - 1
			end

			from
				create {LINKED_LIST [ AST_NODE ]}Result.make
				l.start
			until
				l.is_empty
			loop
				if attached {AST_NODE} l.item as node then
					Result.extend (node)
				elseif attached {LIST [ ANY ]} l.item as list then
					from
						list.start
					until
						list.after
					loop
						l.extend (list.item)
						list.forth
					end
				end
				l.remove
			end
		ensure
			Result /= Void
		end

	ast_children_from_accept : LIST [ AST_NODE ]
		local
			v: ACCEPT_CHECK_VISITOR
		do
			create v
			Current.accept (v)
			Result := v.children_from_accept
		ensure
			Result /= Void
		end

invariant
	properties /= Void
	all_ast_children_have_current_as_parent: ast_children_from_fields.for_all (agent (node: AST_NODE) : BOOLEAN
				do
					Result := (node.parent = Current)
				end)
	accept_visits_all_ast_children: ast_children_from_fields.count = ast_children_from_accept.count

end
