class
	AST_STRUCT_DECLARATION

inherit
	AST_NODE
	ANTLR_TRANSFORMATION_UTILITIES

create
	make_from_antlr

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Art_struct_declaration
		do
			make_root (init_parent)
			specifiers_and_qualifiers := process_specifier_qualifier_list (node.children.first, Current)
			process_struct_declarators (node.children.i_th (2))
		end

feature {ANY}

	specifiers_and_qualifiers: LIST [ AST_DECLARATION_SPECIFIER ]
	struct_declarators: LIST [ AST_STRUCT_DECLARATOR ]

feature {NONE}

	process_struct_declarators (node: ANTLR_AST_NODE)
		require
			node /= Void and then node.type = Art_struct_declarator_list
		do
			from
				create {LINKED_LIST [ AST_STRUCT_DECLARATOR ]}struct_declarators.make
				node.children.start
			until
				node.children.after
			loop
				struct_declarators.extend (create {AST_STRUCT_DECLARATOR}.make_from_antlr (node.children.item, Current))
				node.children.forth
			end
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_struct_declaration (Current)
			if visit_children then
				visit (specifiers_and_qualifiers, v)
				visit (struct_declarators, v)
			end
			v.end_visit_struct_declaration (Current)
			v.post_visit (Current)
		end

invariant
	struct_declarators /= Void and then not struct_declarators.is_empty

end
