class
	AST_STRUCT_OR_UNION

inherit
	AST_EXTERNAL_DECLARATION

create
	make_from_antlr

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then (node.type = C_kw_struct or node.type = C_kw_union)
		do
			make_root (init_parent)
			is_struct := (node.type = C_kw_struct)
			is_union := (node.type = C_kw_union)
			name := node.children.first.token_text
			parse_fields (node.children.i_th (3))
		end

feature {ANY}

	is_struct, is_union: BOOLEAN
	name: STRING
	fields: LIST [ AST_STRUCT_DECLARATION ]

feature {NONE}

	parse_fields (node: ANTLR_AST_NODE)
		require
			node /= Void and then node.type = Art_struct_declaration_list
		do
			from
				create {LINKED_LIST [ AST_STRUCT_DECLARATION ]}fields.make
				node.children.start
			until
				node.children.after
			loop
				fields.extend (create {AST_STRUCT_DECLARATION}.make_from_antlr (node.children.item, Current))
				node.children.forth
			end
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_struct_or_union (Current)
			if visit_children then
				visit (fields, v)
			end
			v.end_visit_struct_or_union (Current)
			v.post_visit (Current)
		end

invariant
	is_struct = not is_union
	name /= Void and then not name.is_empty
	fields /= Void

end
