class
	AST_TRANSLATION_UNIT

inherit
	AST_NODE

create
	make_from_antlr

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE)
		require
			node /= Void and then node.type = Art_translation_unit
		local
			declaration: ANTLR_AST_NODE
		do
			make_root (Void)

			create {LINKED_LIST [ AST_EXTERNAL_DECLARATION ]}declarations.make
			from
				node.children.start
			until
				node.children.after
			loop
				declaration := node.children.item.children.first
				inspect
					declaration.type
				when C_kw_typedef then
				when C_kw_struct, C_kw_union then
					declarations.extend (create {AST_STRUCT_OR_UNION}.make_from_antlr (declaration, Current))
				when Art_variable_declaration then
				end

				node.children.forth
			end
		end

feature {ANY}

	declarations: LIST [ AST_EXTERNAL_DECLARATION ]

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_translation_unit (Current)
			if visit_children then
				visit (declarations, v)
			end
			v.end_visit_translation_unit (Current)
			v.post_visit (Current)
		end

end
