class
	AST_TYPE_SPECIFIER

inherit
	AST_DECLARATION_SPECIFIER

create
	make_from_antlr

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Art_type_specifier
		do
			make_root (init_parent)

			type := node.children.first.type
			inspect
				type
			when C_kw_void, C_kw_char, C_kw_short, C_kw_int, C_kw_long, C_kw_float, C_kw_double, C_kw_signed, C_kw_unsigned then
				-- ok
			when Art_type_id, C_kw_struct, C_kw_union then
				identifier := node.children.first.children.first.token_text
			end
		end

feature {ANY}

	type: INTEGER
	identifier: STRING

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_type_specifier (Current)
			if visit_children then
				-- no children...
			end
			v.end_visit_type_specifier (Current)
			v.post_visit (Current)
		end

invariant
	(type = Art_type_id or type = C_kw_struct or type = C_kw_union) = (identifier /= Void)

end
