class
	ACCEPT_CHECK_VISITOR

inherit
	AST_DEFAULT_VISITOR
		redefine
			default_create,
			pre_visit
		end

feature {NONE}

	default_create
		do
			create { LINKED_LIST [ AST_NODE ] }children_from_accept.make
		end

feature {ANY}

	parent: AST_NODE
	children_from_accept: LIST [ AST_NODE ]

	pre_visit (node: AST_NODE)
		do
			if parent = Void then
				parent := node
			elseif node.parent = parent then
				children_from_accept.extend (node)
			else
				-- TODO: all sub-children will also be visited;
				--       visiting should be cut after the direct children
			end
		end

invariant
	children_from_accept /= Void

end
