class
	TREE_TRANSFORMER

inherit
	TRANSFORMATION_STEP

feature {ANY} -- TRANSFORMATION_STEP

	process (transformer: CODE_TRANSFORMER) : BOOLEAN
		local
			failed: BOOLEAN
			source_file_name: STRING
		do
			if not failed then
				source_file_name := transformer.c_file
				source_file_name := source_file_name.substring (
						source_file_name.last_index_of ('\', source_file_name.count) + 1,
						source_file_name.count)

				transformer.tree := create {AST_TRANSLATION_UNIT}.make_from_antlr (transformer.initial_tree)
				transformer.tree.properties.extend (source_file_name, "source_file_name")

				transformer.initial_tree := Void
				Result := True
			else
				IO.put_string ("#################### [" + description + "] Error: ####################%N")
				IO.put_string ("Transforming the tree failed...")
				Result := False
			end
		rescue
			failed := True
			retry
		end

	description : STRING
		do
			Result := "Transforming Tree"
		end

end
